#include <ESP8266WiFi.h>
#include <FirebaseESP8266.h>

#define FIREBASE_HOST "https://xxxxxxxxxxxxxxx-default-rtdb.firebaseio.com"   // Enter firebase DB URL without "https:// "  and "/" at the end of URL             
#define FIREBASE_AUTH "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"   // Real-time database secret key here

// Your WiFi credentials
#define WIFI_SSID "xxxxxxxxxxxxxxxxxxx" // WIFI SSID here                                   
#define WIFI_PASSWORD "xxxxxxxxxxxxxxxx"  // WIFI password here                  

// Declare the Firebase Data object in the global scope
FirebaseData firebaseData1;
FirebaseData firebaseData2;
FirebaseData firebaseData3;

int led_on = 13; // Connected to D7 pin of NodeMCU
int led_off = 16; // Connected to D0 pin of NodeMCU
int flame_sensor = 12; //Connected to D6 pin of NodeMCU
int buzzer = 4; //Connected to D2 pin of NodeMCU
int relay = 5; //Connected to D1 pin of NodeMCU
int smoke_sensor = A0; //Connected to A0 pin of NodeMCU
int temp_smoke_sensor;
int flame_sensor_read;
String alarm_data;

void setup()
{
  pinMode(led_on, OUTPUT);
  pinMode(led_off, OUTPUT);
  pinMode(flame_sensor, INPUT);
  pinMode(buzzer, OUTPUT);
  pinMode(relay, OUTPUT);
  pinMode(smoke_sensor, INPUT);
  
  Serial.begin(115200);
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);  //connect with wifi
  Serial.print("Connecting to ");
  Serial.print(WIFI_SSID);
  while (WiFi.status() != WL_CONNECTED) 
  {
    Serial.print(".");
    delay(100);
  }
  Serial.println();
  Serial.print("Connected to ");
  Serial.println(WIFI_SSID);
  Serial.print("IP Address is : ");
  Serial.println(WiFi.localIP());  //print local IP address
  Firebase.begin(FIREBASE_HOST, FIREBASE_AUTH);   // connect to firebase
  Firebase.reconnectWiFi(true);
  delay(1000);
}

void loop() 
{
   // Reading alarm data from firebase
   Firebase.getString(firebaseData3, "/iot_fire_sec/alarm_data");
   alarm_data = firebaseData3.stringData();
   Serial.print("ALARM Status:");
   Serial.println(alarm_data);
   delay(100);
  
  flame_sensor_read = digitalRead(flame_sensor); //reading the sensor data on A0 pin
  Firebase.setInt(firebaseData1, "/iot_fire_sec/fire_status/", flame_sensor_read);
  Serial.print("Flame Status:");
  Serial.println(flame_sensor_read);
  if (flame_sensor_read == 0)
  {
    digitalWrite(buzzer, HIGH);
  }
  else if (flame_sensor_read == 1)
  {
    digitalWrite(buzzer, LOW);
  }
  temp_smoke_sensor = analogRead(smoke_sensor);
  Serial.print("Current Gas Level:");
  Serial.println(temp_smoke_sensor);
  Firebase.setInt(firebaseData2, "/iot_fire_sec/smoke_status/", temp_smoke_sensor);
  
  if (alarm_data == "1" && temp_smoke_sensor > 500)
  {
    digitalWrite(led_on, HIGH);
    digitalWrite(led_off, LOW);
    digitalWrite(relay, HIGH);
    digitalWrite(buzzer, HIGH);
  }
  else if (alarm_data == "0" && temp_smoke_sensor > 500)
   {
    digitalWrite(led_on, LOW);
    digitalWrite(led_off, HIGH);
    digitalWrite(relay, LOW);
    digitalWrite(buzzer, LOW);
   }
  else if (alarm_data == "1" && temp_smoke_sensor < 500)
   {
    digitalWrite(led_on, HIGH);
    digitalWrite(led_off, LOW);
    digitalWrite(relay, LOW);
    digitalWrite(buzzer, LOW);
   }
  else if (alarm_data == "0" && temp_smoke_sensor < 500)
  {
    digitalWrite(led_on, LOW);
    digitalWrite(led_off, HIGH);
    digitalWrite(relay, LOW);
    digitalWrite(buzzer, LOW);
   }
}
